package services

import (
	"errors"
	"hongze/hongze_api/models"
	"hongze/hongze_api/utils"
	"strconv"
)

func CheckUserPermission(userId int) (status int, err error) {
	if userId > 0 {
		wxUser, err := models.GetWxUserItemByUserId(userId)
		if err != nil {
			if err.Error() == utils.ErrNoRow() {
				status = 40001
				err = errors.New("用户信息不存在：userId:" + strconv.Itoa(userId))
				return status,err
			}
			status = 40001
			err = errors.New("获取用户信息失败：userId:" + strconv.Itoa(userId) + ";Err:" + err.Error())
			return status, err
		}
		if wxUser == nil {
			status = 40001
			err = errors.New("获取用户信息失败：userId:" + strconv.Itoa(userId))
			return status, err
		}
		companyId := wxUser.CompanyId
		company, err := models.GetCompanyById(companyId)
		if err != nil {
			status = 40001
			err = errors.New("获取客户信息失败：userId:" + strconv.Itoa(userId) + ";Err:" + err.Error())
			return status, err
		}
		if company == nil {
			status = 40001
			err = errors.New("客户信息不存在：userId:" + strconv.Itoa(userId))
			return status, err
		}
		if company.IsFeeCustomer == 1 {
			status = 0
		} else {
			status = 40002
			err = errors.New("非付费用户" + strconv.Itoa(userId))
		}
	} else {
		status = 40001
		err = errors.New("用户id错误")
	}
	return
}
